From 00dcb01be8e7e47ab5f618dd3b0280eaf0058b85 Mon Sep 17 00:00:00 2001
From: "Endi S. Dewata" <edewata@redhat.com>
Date: Mon, 25 Nov 2013 12:30:40 -0500
Subject: [PATCH] Updated version to 10.2.0-0.1.

---
 scripts/compose_dogtag_pki_theme_packages |  2 +-
 scripts/compose_ipa_pki_theme_packages    |  2 +-
 scripts/compose_pki_console_packages      |  2 +-
 scripts/compose_pki_core_packages         |  2 +-
 scripts/compose_pki_migrate_packages      |  2 +-
 scripts/compose_pki_ra_packages           |  2 +-
 scripts/compose_pki_tps_packages          |  2 +-
 specs/dogtag-pki-theme.spec               |  7 +++++--
 specs/dogtag-pki.spec                     | 23 +++++++++++++----------
 specs/ipa-pki-theme.spec                  |  7 +++++--
 specs/pki-console.spec                    |  7 +++++--
 specs/pki-core.spec                       |  7 +++++--
 specs/pki-migrate.spec                    |  7 +++++--
 specs/pki-ra.spec                         | 11 +++++++----
 specs/pki-tps.spec                        | 13 ++++++++-----
 15 files changed, 60 insertions(+), 36 deletions(-)

diff --git a/scripts/compose_dogtag_pki_theme_packages b/scripts/compose_dogtag_pki_theme_packages
index 5b52acaef18d1c885506c3fbf13e72641cec314b..57a9e72781cd400ff33b50bf70a3d5d81e8469b5 100755
--- a/scripts/compose_dogtag_pki_theme_packages
+++ b/scripts/compose_dogtag_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 DOGTAG_PKI_THEME="dogtag-pki-theme"
-DOGTAG_PKI_THEME_VERSION="10.1.0"
+DOGTAG_PKI_THEME_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_ipa_pki_theme_packages b/scripts/compose_ipa_pki_theme_packages
index 8cd8768b003968b99f739faa8db2956fba802899..1742e45650a1be9f430b4f51d1826a633676a8e0 100755
--- a/scripts/compose_ipa_pki_theme_packages
+++ b/scripts/compose_ipa_pki_theme_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 IPA_PKI_THEME="ipa-pki-theme"
-IPA_PKI_THEME_VERSION="10.1.0"
+IPA_PKI_THEME_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_pki_console_packages b/scripts/compose_pki_console_packages
index 4e5bc66ba3dbce7a7a9e732c9bd24aac47f337d7..0a3844bdc62732ef2e938455ce36ded625b85191 100755
--- a/scripts/compose_pki_console_packages
+++ b/scripts/compose_pki_console_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CONSOLE="pki-console"
-PKI_CONSOLE_VERSION="10.1.0"
+PKI_CONSOLE_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_pki_core_packages b/scripts/compose_pki_core_packages
index ab955827d593794cdfc35768ec9f64234155e640..23d58e0d0e4f4faeff43a4141e97f33c067bcdfb 100755
--- a/scripts/compose_pki_core_packages
+++ b/scripts/compose_pki_core_packages
@@ -30,7 +30,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_CORE="pki-core"
-PKI_CORE_VERSION="10.1.0"
+PKI_CORE_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_pki_migrate_packages b/scripts/compose_pki_migrate_packages
index be93c42c1d45aab24495d617871d4b20540855fb..a93df22552c4f9f9a28a9457794c4ad925bfcb90 100755
--- a/scripts/compose_pki_migrate_packages
+++ b/scripts/compose_pki_migrate_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_MIGRATE="pki-migrate"
-PKI_MIGRATE_VERSION="10.1.0"
+PKI_MIGRATE_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_pki_ra_packages b/scripts/compose_pki_ra_packages
index 9aa4dda141d570c2d8677cb417550178da03e006..5c37a52c8ac702c2a40d58b421609cc915987dba 100755
--- a/scripts/compose_pki_ra_packages
+++ b/scripts/compose_pki_ra_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_RA="pki-ra"
-PKI_RA_VERSION="10.1.0"
+PKI_RA_VERSION="10.2.0"
 
 
 ##
diff --git a/scripts/compose_pki_tps_packages b/scripts/compose_pki_tps_packages
index 4ffa83cf50f61b97bc2d5cdb315b5c5828a86cbc..0e7f85a44f79c29f43453f06685eb8e3e8f04acf 100755
--- a/scripts/compose_pki_tps_packages
+++ b/scripts/compose_pki_tps_packages
@@ -31,7 +31,7 @@ PKI_PWD=`pwd`
 ##
 
 PKI_TPS="pki-tps"
-PKI_TPS_VERSION="10.1.0"
+PKI_TPS_VERSION="10.2.0"
 
 
 ##
diff --git a/specs/dogtag-pki-theme.spec b/specs/dogtag-pki-theme.spec
index 8e44d4559f5f3907eef8c8eddafb4a123daf98b8..f985cdff0ae6d79d231f3710bb79913aedfb86c5 100644
--- a/specs/dogtag-pki-theme.spec
+++ b/specs/dogtag-pki-theme.spec
@@ -1,6 +1,6 @@
 Name:             dogtag-pki-theme
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - Dogtag PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -213,6 +213,9 @@ cd build
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/dogtag-pki.spec b/specs/dogtag-pki.spec
index 498645d0b158b2dda01dd3320fd0d00786c4bd49..6a64fa032850798ff562ce9a4caa9254182aae25 100644
--- a/specs/dogtag-pki.spec
+++ b/specs/dogtag-pki.spec
@@ -1,7 +1,7 @@
 Summary:          Dogtag Public Key Infrastructure (PKI) Suite
 Name:             dogtag-pki
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 # The entire source code is GPLv2 except for 'pki-tps' which is LGPLv2
 License:          GPLv2 and LGPLv2
 URL:              http://pki.fedoraproject.org/
@@ -9,16 +9,16 @@ Group:            System Environment/Daemons
 BuildRoot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 BuildArch:        noarch
 
-%define dogtag_pki_theme_version   10.1.0
+%define dogtag_pki_theme_version   10.2.0
 %define esc_version                1.1.0
 %define jss_version                4.2.6-28
-%define pki_core_version           10.1.0
-%define pki_kra_version            10.1.0
-%define pki_ocsp_version           10.1.0
-%define pki_ra_version             10.1.0
-%define pki_tks_version            10.1.0
-%define pki_tps_version            10.1.0
-%define pki_console_version        10.1.0
+%define pki_core_version           10.2.0
+%define pki_kra_version            10.2.0
+%define pki_ocsp_version           10.2.0
+%define pki_ra_version             10.2.0
+%define pki_tks_version            10.2.0
+%define pki_tps_version            10.2.0
+%define pki_console_version        10.2.0
 %define tomcatjss_version          7.1.0
 
 Requires:         apache-commons-codec
@@ -125,6 +125,9 @@ rm -rf %{buildroot}
 %doc README
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/ipa-pki-theme.spec b/specs/ipa-pki-theme.spec
index c7e47da2a785940005313654a9e4c2ec2d593183..b96afa51bfed85df81bbd5a943d8fd8f1f954d2d 100644
--- a/specs/ipa-pki-theme.spec
+++ b/specs/ipa-pki-theme.spec
@@ -1,6 +1,6 @@
 Name:             ipa-pki-theme
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - IPA PKI Theme Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -115,6 +115,9 @@ cd build
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/pki-console.spec b/specs/pki-console.spec
index 715ff6c8d3555d5fb95fb5270758011938076b0c..c71878daedad71191b7f82a624ea71d95f61c3c5 100644
--- a/specs/pki-console.spec
+++ b/specs/pki-console.spec
@@ -1,6 +1,6 @@
 Name:             pki-console
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - PKI Console
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -80,6 +80,9 @@ cd build
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/pki-core.spec b/specs/pki-core.spec
index de6516939ac421aa6bba380997511c9f5f3f505e..9b4171547b7784b5ec17d14a9c5522015c1514dc 100644
--- a/specs/pki-core.spec
+++ b/specs/pki-core.spec
@@ -4,8 +4,8 @@ distutils.sysconfig import get_python_lib; print(get_python_lib())")}
 distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
 
 Name:             pki-core
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - PKI Core Components
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -966,6 +966,9 @@ fi
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/pki-migrate.spec b/specs/pki-migrate.spec
index a025482e75d254dbd36bb9a3a0e420f468e4453e..8414874aafc0ac88257df35cff23d5b585ea0011 100644
--- a/specs/pki-migrate.spec
+++ b/specs/pki-migrate.spec
@@ -1,6 +1,6 @@
 Name:             pki-migrate
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Red Hat Certificate System - PKI Migration Scripts
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -71,6 +71,9 @@ cd build
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/pki-ra.spec b/specs/pki-ra.spec
index 03c9ad931ff5f5e472f9b30719594889b3f43e7e..bea21cf2fd3bd371f887f558374d46d1e7e295ff 100644
--- a/specs/pki-ra.spec
+++ b/specs/pki-ra.spec
@@ -1,6 +1,6 @@
 Name:             pki-ra
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - Registration Authority
 URL:              http://pki.fedoraproject.org/
 License:          GPLv2
@@ -21,8 +21,8 @@ Requires:         mod_perl >= 1.99_16
 Requires:         mod_revocator >= 1.0.3
 Requires:         nss >= 3.14.3
 Requires:         nss-tools >= 3.14.3
-Requires:         pki-server >= 10.1.0
-Requires:         pki-server-theme >= 10.1.0
+Requires:         pki-server >= 10.2.0
+Requires:         pki-server-theme >= 10.2.0
 Requires:         perl-DBD-SQLite
 Requires:         sqlite
 Requires:         /usr/sbin/sendmail
@@ -197,6 +197,9 @@ fi
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Trac Ticket 788 - Clean up spec files
 - Update release number for release build
diff --git a/specs/pki-tps.spec b/specs/pki-tps.spec
index 2ade49c56455a26f7070413f086698b506bab850..0f5a3e31c8f5db41fcb249a3f17c5bad8c2ccf8b 100644
--- a/specs/pki-tps.spec
+++ b/specs/pki-tps.spec
@@ -1,6 +1,6 @@
 Name:             pki-tps
-Version:          10.1.0
-Release:          1%{?dist}
+Version:          10.2.0
+Release:          0.1%{?dist}
 Summary:          Certificate System - Token Processing System
 URL:              http://pki.fedoraproject.org/
 License:          LGPLv2
@@ -18,7 +18,7 @@ BuildRequires:    openldap-devel
 BuildRequires:    nspr-devel
 BuildRequires:    nss-devel >= 3.14.3
 BuildRequires:    pcre-devel
-BuildRequires:    pki-server >= 10.1.0
+BuildRequires:    pki-server >= 10.2.0
 BuildRequires:    python
 BuildRequires:    systemd
 BuildRequires:    svrcore-devel
@@ -33,8 +33,8 @@ Requires:         nss >= 3.14.3
 Requires:         nss-tools >= 3.14.3
 Requires:         openldap-clients
 Requires:         perl-Mozilla-LDAP
-Requires:         pki-server >= 10.1.0
-Requires:         pki-symkey >= 10.1.0
+Requires:         pki-server >= 10.2.0
+Requires:         pki-symkey >= 10.2.0
 
 Requires(post):   systemd-units
 Requires(preun):  systemd-units
@@ -239,6 +239,9 @@ fi
 
 
 %changelog
+* Fri Nov 22 2013 Dogtag Team <pki-devel@redhat.com> 10.2.0-0.1
+- Updated version number to 10.2.0-0.1.
+
 * Fri Nov 15 2013 Ade Lee <alee@redhat.com> 10.1.0-1
 - Update release number for release build
 
-- 
1.8.4.2